Subject: Re: [PATCH] mergetools: add config option to disable auto-merge

From: David Aguilar <[email-masked]>
Date: Thu, 18 Jun 2015 01:42:53 -0700

On Wed, Jun 17, 2015 at 10:27:58PM -0400, Mike Rappazzo wrote:
> On Wed, Jun 17, 2015 at 3:41 PM, Junio C Hamano <[email-masked]> wrote:
> > Michael Rappazzo <[email-masked]> writes:
> >
> >> For some mergetools, the current invocation of git mergetool will
> >> include an auto-merge flag.  By default the flag is included, however if
> >> the git config option 'merge.automerge' is set to 'false', then that
> >> flag will now be omitted.
> >
> > ... and why is the "automerge" a bad thing that user would want to
> > avoid triggering under which condition?  That description may not
> > have to be in the proposed log message, but it would help users when
> > they decide if they want to use the configuration to describe it in
> > the mergetool.automerge configuration.
> >
> > And depending on the answer to the above question, a configuration
> > variable may turn out be a bad mechanism to customize this (namely,
> > set-and-forget configuration variable is a bad match for a knob that
> > is more "per invocation" than "user taste").
> >
> > Is this not about "automerge" but more about "always-show-UI because
> > I like GUI?"  Then that may be a "user taste" thing that is a good
> > match for a configuration variable.  I simply cannot tell from what
> > was in the message I am responding to.
> 
> I feel that the auto-merge takes away the context of the changes.
> 
> I use araxis merge as my mergetool of choice.  I almost always immediately
> undo the auto-merge.  After taking a moment to look at each file, I will
> then (usually) use the keyboard shortcut for auto-merge.
> 
> It sure would be nice to "set-and-forget" a config variable to remove the
> annoyance of having to undo the auto-merge.  I think that this config
> option is reasonable.  Perhaps my documentation leaves something to be
> desired.  I can take another stab at it.

If this is the case then I would recommend making it more
granular.  Just because Araxis' automerge is undesirable does
not mean that some other tools' automerge is as well.
e.g. the config variable could be "mergetool.<tool>.automerge"
rather than the top-level "mergetool.automerge" variable.

But, as Junio suggested, having a command-line flag to skip the
behavior might be a better first step.  Something like,
"git mergetool --no-automerge".

Most of Git's behavior that can be modified via configuration
can also be modified on the command-line, so exposing this
feature as a flag would probably be a good idea.

Even without a config variable, it can still be fire-and-forget
convenient by using a git alias to supply the flag.

In lieu of any of these features, another option is that you can
override the default command by setting "mergetool.araxis.cmd",
and "git mergetool" will use your definition rather than its
built-in command.  We left that escape hatch in for just this
purpose.

I'm curious, is this a common use case?  I'm personally not a
good judge of that, but I'll let the list chime in.  Thoughts?
-- 
David